<?php
namespace Planejamento\Repositories;

class Distcard extends \Doctrine\ORM\EntityRepository
{
    public static function buscaNrdistcard($cdfilial, $data, $nrcardapio, $cdservfili, $cdcliente, $cddestfili){

        $sql = <<<SQL
SELECT D.NRDISTCARD  FROM DISTCARD D
       INNER JOIN CARDADIA C  ON C.CDFILIAL = D.CDFILIAL AND
        C.NRCARDAPIO = D.NRCARDAPIO
WHERE C.CDFILIAL = :CDFILIAL
        AND C.DTCARDAPIO = :DTCARDAPIO AND D.NRCARDAPIO=:NRCARDAPIO AND C.CDSERVFILI =:CDSERVFILI
        AND  (((:P_CDCLIENTE IS NULL) AND (D.CDCLIENTE IS NULL)) OR
	                                  (D.CDCLIENTE = :P_CDCLIENTE AND
	                                   D.CDDESTFILI = :P_CDDESTFILI))
SQL;
        $params = array(
            'CDFILIAL' => $cdfilial,
            'DTCARDAPIO' =>$data,
            'NRCARDAPIO' =>$nrcardapio,
            'CDSERVFILI' =>$cdservfili,
            'P_CDCLIENTE' =>$cdcliente,
            'P_CDDESTFILI'=>$cddestfili);


        try{
            $conn = \Setforms2\Shared\Registry::getEntityManager();
            $conn = $conn->getConnection();
            return $conn-> fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    public static function buscaIdsituacao($nrdistcard){
        $sql = <<<SQL
SELECT NRDISTCARD, IDSITUACAO
FROM DISTCARD
WHERE NRDISTCARD = '$nrdistcard'
SQL;

        try{
            $conn = \Setforms2\Shared\Registry::getEntityManager();
            $conn = $conn->getConnection();
            return $conn-> fetchAll($sql);
        } catch (\Exception $e) {
            throw $e;
        }
    }
    public static function busca_Pratos($nrdistcard){
        $sql =<<<SQL
         SELECT C.NRDISTCARD, C.NRSEQPRATCAR, C.CDFILAUXPRAT, C.CDPRATO,
       C.QTTOTCOMENSAIS, C.QTTOTPRATO, C.QTTOTEXTRA,
       ROUND(C.QTTOTCOMENSAIS - NVL(U.QTCOMENSAIS, 0), 5) AS QTCOMENSAIS,
       ROUND(C.QTTOTPRATO - NVL(U.QTPRATO, 0), 5) AS QTPRATO,
       ROUND(C.QTTOTEXTRA - NVL(U.QTEXTRA, 0), 5) AS  QTEXTRA,
       CC.NRORDPRATCAR, C.QTPORPESSOA, P.NMPRATO, P.SGUNIDADE
FROM CNFDISTCARD C
    INNER JOIN DISTCARD D ON D.NRDISTCARD = C.NRDISTCARD
    INNER JOIN PRATO P ON P.CDPRATO = C.CDPRATO AND P.CDFILAUXPRAT = C.CDFILAUXPRAT
    LEFT JOIN COMPCARD CC ON CC.CDFILIAL = D.CDFILIAL AND
        CC.NRCARDAPIO = D.NRCARDAPIO AND
        CC.NRSEQPRATCAR = C.NRSEQPRATCAR
     LEFT JOIN
        (
            SELECT NRDISTCARD, NRSEQPRATCAR, SUM(QTCOMENSAIS) AS QTCOMENSAIS,
            SUM(QTPRATO) AS QTPRATO, SUM(QTEXTRA) AS QTEXTRA
       FROM ITEMBDISTCARD
       WHERE NRDISTCARD = :NRDISTCARD
     GROUP BY NRDISTCARD, NRSEQPRATCAR
    ) U ON U.NRSEQPRATCAR = C.NRSEQPRATCAR
WHERE C.NRDISTCARD = :NRDISTCARD
SQL;
        $params = array(
            'NRDISTCARD'=>$nrdistcard);


        try{
            $conn = \Setforms2\Shared\Registry::getEntityManager();
            $conn = $conn->getConnection();
            return $conn-> fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public static function RetornaListadePratosCardapio($cdfilial, $nrcardapio, $cdservfili){
        $sql =<<<SQL
SELECT DISTINCT C.CDPRATO,P. CDFILAUXPRAT
FROM COMPCARD C
INNER JOIN PRATO P ON P.CDPRATO = C.CDPRATO AND P.CDFILAUXPRAT = C.CDFILAUXPRAT
INNER JOIN CARDADIA CA ON CA.NRCARDAPIO = C.NRCARDAPIO
WHERE C.CDFILIAL =:CDFILIAL and C.NRCARDAPIO =:NRCARDAPIO AND CA.CDSERVFILI =:CDSERVFILI
SQL;
        $params = array(
            'CDFILIAL'=>$cdfilial,
            'NRCARDAPIO'=>$nrcardapio,
            'CDSERVFILI'=>$cdservfili);


        try{
            $conn = \Setforms2\Shared\Registry::getEntityManager();
            $conn = $conn->getConnection();
            return $conn-> fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }

    }

    public static function RetornaQtdPratoPorEmbalagem($cdcontainer, $cdfiliauxprat, $cdprato){
        $sql =<<<SQL
SELECT VRQTDEPRATEMB
FROM RELPRATEMB
WHERE CDCONTAINER = :P_CDCONTAINER
  AND CDFILAUXPRAT = :P_CDFILAUXPRAT
  AND CDPRATO = :P_CDPRATO
SQL;
        $params = array(
            'P_CDCONTAINER'=>$cdcontainer,
            'P_CDFILAUXPRAT'=>$cdfiliauxprat,
            'P_CDPRATO'=>$cdprato);


        try{
            $conn = \Setforms2\Shared\Registry::getEntityManager();
            $conn = $conn->getConnection();
            return $conn-> fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }

    }

    public static function RetornaContainerDoPrato($cdprato){
        $sql =<<<SQL
SELECT CDCONTAINER FROM RELPRATEMB WHERE CDPRATO =:CDPRATO

SQL;
        $params = array(
            'CDPRATO'=>$cdprato);

        try{
            $conn = \Setforms2\Shared\Registry::getEntityManager();
            $conn = $conn->getConnection();
            return $conn-> fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }

    }

    public static function RetornaNrembdistcardLinhaAtiva($nrdistcard, $nrseqprat){
        $sql=<<<SQL
SELECT EMBDISTCARD.NREMBDISTCARD FROM EMBDISTCARD
LEFT JOIN ITEMBDISTCARD ON
ITEMBDISTCARD.NRDISTCARD = EMBDISTCARD.NRDISTCARD AND
ITEMBDISTCARD.NREMBDISTCARD = EMBDISTCARD.NREMBDISTCARD AND
ITEMBDISTCARD.NRORG = EMBDISTCARD.NRORG
WHERE ITEMBDISTCARD.NRDISTCARD = :NRDIST AND ITEMBDISTCARD.NRSEQPRATCAR = :NRSEQPRAT
SQL;
        $params = array(
            'NRDIST'=>$nrdistcard,
            'NRSEQPRAT'=>$nrseqprat);

        try{
            $conn = \Setforms2\Shared\Registry::getEntityManager();
            $conn = $conn->getConnection();
            return $conn-> fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public static function DeletaDistcard($nrdistcard){
        $sql = <<<SQL
DELETE FROM DISTCARD
WHERE NRDISTCARD = :P_NRDISTCARD
SQL;
        $params = array(
            'P_NRDISTCARD' =>$nrdistcard);

        try{
            $conn = \Setforms2\Runtime\Connection::getInstance();
            $conn->execute($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public static function AtualizaSituacao($nrdistcard, $idsituacao){
        $sql = <<<SQL
UPDATE DISTCARD SET IDSITUACAO =:P_IDSITUACAO WHERE NRDISTCARD = :P_NRDISTCARD
SQL;
        $params = array(
            'P_NRDISTCARD' =>$nrdistcard,
            'P_IDSITUACAO' =>$idsituacao);

        try{
            $conn = \Setforms2\Runtime\Connection::getInstance();
            $conn->execute($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }

    }


}