<?php

/**
 * Gpepessoa
 *
 * This class has been auto-generated by the Doctrine ORM Framework
 *
 * @package    DbModel
 * @subpackage Model
 * @author     alessandrobartels - 04/03/2011 15:31:39 <development@setforms.com>
 * @version    SVN: $Id: Builder.php 6508 2009-10-14 06:28:49Z jwage $
 */
class Gpepessoa extends DaoGpePessoa
{


    /**
     * Enter description here ...
     *
     * @param integer $nr_org    Numero da Organizacao.
     * @param integer $nr_pessoa Numero da Pessoa.
     *
     * @return GpepessoahEntity
     */
    private static function _retornaUltimoHistorico($nr_org, $nr_pessoa){
        $pessoa_historico = Gpepessoah::getObjectsByWhere(
            'NRORG = ? AND
             NRPESSOA = ?',
            array(
             $nr_org,
             $nr_pessoa,
            )
        );
        $ph = end($pessoa_historico);
        return $ph;

    }


     /**
      * Retorna instancia de GpepessoaEntity.
      *
      * @param integer $nrOrg    Numero da Org.
      * @param integer $nrPessoa Numero da Pessoa.
      *
      * @return null | GpepessoaEntity
      */
    public static function retornaPessoa($nrOrg, $nrPessoa){
        $pessoa = self::getObjectByWhere(
            'NRORG = ?
             AND NRPESSOA = ?',
            array(
             $nrPessoa, $nrOrg,
            )
        );

        return $pessoa;
    }


    /**
     * Retorna instancia de GpepessoaEntity agregado a GpepessoahEntity.
     *
     * @param integer    $nrOrg          Numero da Org. de Trabalho.
     * @param TkDateTime $mesCompetencia Mes de competencia.
     * @param integer    $nrPessoa       Numero da Pessoa.
     *
     * @return null | GpepessoaEntity
     */
    public static function retornaPessoaAtual($nrOrg, TkDateTime $mesCompetencia, $nrPessoa){
        $pessoa = self::getObjectByWhere(
            'NRPESSOA = ?
             AND NRORG = ?',
            array(
             $nrPessoa, $nrOrg,
            )
        );

        $dao = $pessoa->getDao();
        // BORBA 19/03/2013 Metodo end() a principio deve ser mantido, mesmo que seja retornado somente um historico o createObjectsFromArray cria um array de objetos;
        $historico = end(
                        Gpepessoah::retornaPessoaHistorico($nrOrg, $mesCompetencia, $dao->NRPESSOA)
                        );
        $pessoa->historico = $historico;

        return $pessoa;
    }


    /**
     * Retorna lista de objetos Gpepessoa.
     *
     * @param integer $nr_org         N�mero da Organiza��o.
     * @param integer $nr_parcnegocio N�mero do Parceiro de Negocio.
     *
     * @return GpepessoaEntity
     */

    public static function retornaPessoaPorParceiro($nr_org, $nr_parcnegocio){
        $pessoa = self::getObjectByWhere(
            'NRORG = ?
             AND NRPARCNEGOCIO = ?',
            array(
             $nr_org, $nr_parcnegocio,
            )
        );
        
        if (is_object($pessoa) === true) {
            $dao = $pessoa->getDao();
            $historico = self::_retornaUltimoHistorico($nr_org, $dao->NRPESSOA);
            $pessoa->historico = $historico;
        }

        return $pessoa;
    }


}